<!--
  ~ EVS Client is part of the Gazelle Test Bed
  ~ Copyright (C) 2006-2016 IHE
  ~ mailto :eric DOT poiseau AT inria DOT fr
  ~
  ~ See the NOTICE file distributed with this work for additional information
  ~ regarding copyright ownership.  This code is licensed
  ~ to you under the Apache License, Version 2.0 (the
  ~ "License"); you may not use this file except in compliance
  ~ with the License.  You may obtain a copy of the License at
  ~
  ~   http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~ Unless required by applicable law or agreed to in writing,
  ~ software distributed under the License is distributed on an
  ~ "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
  ~ KIND, either express or implied.  See the License for the
  ~ specific language governing permissions and limitations
  ~ under the License.
  -->

<ui:composition xmlns:h="http://java.sun.com/jsf/html" xmlns:s="http://jboss.org/schema/seam/taglib"
                xmlns:g="http://www.ihe.net/gazelle" xmlns:f="http://java.sun.com/jsf/core"
                xmlns:rich="http://richfaces.org/rich" xmlns:gdk="http://www.ihe.net/gazellecdk"
                xmlns:a4j="http://richfaces.org/a4j" xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns="http://www.w3.org/1999/xhtml">

    <h:form id="edition_form">
        <s:token id="editConfTokenId" allowMultiplePosts="true"/>
        <ui:decorate template="/layout/popup/_popup_title_footer.xhtml">
            <ui:param name="popup_id" value="modif_config"/>
            <ui:param name="styleClass" value="modal-lg"/>
            <ui:define name="popup_title">
                <h:outputText value="#{messages['net.ihe.gazelle.mca.EditConfiguration']}"/>
            </ui:define>

            <s:div styleClass="form-horizontal">

                <s:decorate id="configDocType" template="/layout/form/_form_field_horizontal_3-9.xhtml">
                    <ui:param name="id" value="docTypeInputId"/>
                    <ui:param name="styleClass" value=""/>
                    <ui:define name="label">
                        <h:outputText value="#{messages['net.ihe.gazelle.mca.DocumentType']}"/>
                        <ui:decorate template="/config/descriptionPopover/_description_popover.xhtml">
                            <ui:param name="id" value="docTypeEditId"/>
                            <ui:define name="content">
                                <h:outputText value="#{messages['net.ihe.gazelle.mca.TheLabelThatWillBeUsedForDetectedPartsInAnalysis']}"/>
                            </ui:define>
                        </ui:decorate>
                    </ui:define>
                    <h:inputText id="docTypeInputId" value="#{configBeanGui.getSelectedConfig().docType}" required="true"
                                 styleClass="form-control">
                        <a4j:ajax  event="blur" render="configDocType" execute="@this"/>
                    </h:inputText>
                </s:decorate>

                <s:decorate id="configValidationType" template="/layout/form/_form_field_horizontal_3-9.xhtml">
                    <ui:param name="id" value="validationTypeInputId"/>
                    <ui:param name="styleClass" value=""/>
                    <ui:define name="label">
                        <h:outputText value="#{messages['net.ihe.gazelle.mca.AssociatedValidationType']}"/>
                        <ui:decorate template="/config/descriptionPopover/_description_popover.xhtml">
                            <ui:param name="id" value="validationTypeEditId"/>
                            <ui:define name="content">
                                <h:outputText value="#{messages['net.ihe.gazelle.mca.TheValidationTypeThatWillBeSentToTheRemoteValida']}"/>
                            </ui:define>
                        </ui:decorate>
                    </ui:define>
                    <h:selectOneMenu id="validationTypeInputId" value="#{configBeanGui.getSelectedConfig().validationType}"
                                     styleClass="form-control gzl-form-control gzl-select-text">
                        <f:selectItem itemValue="#{null}" itemLabel="#{messages['net.ihe.gazelle.mca.NoValidationType']}" />
                        <f:selectItems value="#{configBeanGui.getValidationTypes()}"/>
                        <a4j:ajax event="change" render="configValidationType" execute="@this"/>
                    </h:selectOneMenu>
                </s:decorate>

                <s:div rendered="#{configBeanGui.getSelectedConfig() != null and configBeanGui.getSelectedContentAnalysisConfig() != null}">

                    <s:decorate id="configUnwantedContent" template="/layout/form/_form_field_horizontal_3-9.xhtml">
                        <ui:param name="id" value="unwantedContentInputId"/>
                        <ui:param name="styleClass" value=""/>
                        <ui:define name="label">
                            <h:outputText value="#{messages['net.ihe.gazelle.mca.UnwantedContent']}"/>
                            <ui:decorate template="/config/descriptionPopover/_description_popover.xhtml">
                                <ui:param name="id" value="unwantedContentEditId"/>
                                <ui:define name="content">
                                    <h:outputText value="#{messages['net.ihe.gazelle.mca.StringThatIsNotWantedWithinTheStringContentOfThe']}"/>
                                </ui:define>
                            </ui:decorate>
                        </ui:define>
                        <h:inputText id="unwantedContentInputId" value="#{configBeanGui.selectedContentAnalysisConfig.unwantedContent}"
                                     styleClass="form-control">
                            <a4j:ajax  event="blur" render="configUnwantedContent" execute="@this"/>
                        </h:inputText>
                    </s:decorate>

                    <s:decorate id="configBytePattern" template="/layout/form/_form_field_horizontal_3-9.xhtml">
                        <ui:param name="id" value="bytePatternInputId"/>
                        <ui:param name="styleClass" value=""/>
                        <ui:define name="label">
                            <h:outputText value="#{messages['net.ihe.gazelle.mca.BytePattern']}"/>
                            <ui:decorate template="/config/descriptionPopover/_description_popover.xhtml">
                                <ui:param name="id" value="bytePatternEditId"/>
                                <ui:define name="content">
                                    <h:outputText value="#{messages['net.ihe.gazelle.mca.BytePatternThatMustBeDetectedAtTheBeginningOfThe']}"/>
                                </ui:define>
                            </ui:decorate>
                        </ui:define>
                        <h:inputTextarea id="bytePatternInputId" value="#{configBeanGui.selectedBytePattern}"
                                     styleClass="form-control" readonly="false" rows="8">
                            <a4j:ajax  event="blur" render="configBytePattern" execute="@this"/>
                        </h:inputTextarea>
                    </s:decorate>

                    <s:decorate id="configStartsWith" template="/layout/form/_form_field_horizontal_3-9.xhtml">
                        <ui:param name="id" value="startsWithInputId"/>
                        <ui:param name="styleClass" value=""/>
                        <ui:define name="label">
                            <h:outputText value="#{messages['net.ihe.gazelle.mca.StartElements']}"/>
                            <ui:decorate template="/config/descriptionPopover/_description_popover.xhtml">
                                <ui:param name="id" value="startElementsEditId"/>
                                <ui:define name="content">
                                    <h:outputText value="#{messages['net.ihe.gazelle.mca.AListOfStringElementsAnalyzedObjectContentMustSt']}"/>
                                </ui:define>
                            </ui:decorate>
                        </ui:define>

                        <h:selectOneListbox id="startsWithInputId" size="10" value="#{configBeanGui.selectedStartsWith}"
                                            onchange="#{configBeanGui.changeStartsWith()}" render="configStartsWith"
                                            rendered="#{!configBeanGui.getSelectedContentAnalysisConfig().getStartsWith().isEmpty() and
                                                        configBeanGui.getSelectedContentAnalysisConfig().getStartsWith() != null}">
                            <f:ajax execute="@this" render="configStartsWith"/>
                            <f:selectItems value="#{configBeanGui.selectedContentAnalysisConfig.startsWith}"/>
                            <f:attribute name="beanattr" value="#{configBeanGui}"/>
                        </h:selectOneListbox>
                        <br/>
                        <s:div rendered="#{configBeanGui.displayedStartsWith != null}">
                            <h:inputText id="startsWith" value="#{configBeanGui.displayedStartsWith}"
                                         size="30"/>
                            <br/><br/>
                        </s:div>
                        <a4j:commandButton value="#{messages['net.ihe.gazelle.mca.New']}"
                                           styleClass="gzl-btn-blue"
                                           render="configStartsWith, configDocType"
                                           actionListener="#{configBeanGui.newStartsWith()}"/>
                        <a4j:commandButton id="edit" value="#{messages['net.ihe.gazelle.mca.Edit']}"
                                           styleClass="gzl-btn-blue"
                                           rendered="#{configBeanGui.selectedStartsWith != null}"
                                           render="configStartsWith, configDocType"
                                           actionListener="#{configBeanGui.editStartsWith()}"/>
                        <a4j:commandButton id="save" value="#{messages['net.ihe.gazelle.mca.Save']}"
                                           styleClass="gzl-btn-blue"
                                           render="configStartsWith, configDocType"
                                           rendered="#{configBeanGui.displayedStartsWith != null}"
                                           actionListener="#{configBeanGui.saveStartsWith()}"/>
                        <a4j:commandButton id="delete" value="#{messages['net.ihe.gazelle.mca.Delete']}"
                                           styleClass="gzl-btn-blue"
                                           render="configStartsWith, configDocType"
                                           rendered="#{configBeanGui.selectedStartsWith != null}"
                                           actionListener="#{configBeanGui.deleteStartsWith()}"/>
                        <a4j:commandButton value="#{messages['net.ihe.gazelle.mca.Cancel']}"
                                           rendered="#{configBeanGui.selectedStartsWith != null or configBeanGui.displayedStartsWith != null}"
                                           render="configStartsWith, configDocType"
                                           styleClass="gzl-btn-blue"
                                           actionListener="#{configBeanGui.cancel()}"/>
                    </s:decorate>

                    <s:decorate id="configStringPattern" template="/layout/form/_form_field_horizontal_3-9.xhtml">
                        <ui:param name="id" value="stringPatternInputId"/>
                        <ui:param name="styleClass" value=""/>
                        <ui:define name="label">
                            <h:outputText value="#{messages['net.ihe.gazelle.mca.Regex']}"/>
                            <ui:decorate template="/config/descriptionPopover/_description_popover.xhtml">
                                <ui:param name="id" value="stringPatternEditId"/>
                                <ui:define name="content">
                                    <h:outputText value="#{messages['net.ihe.gazelle.mca.RegularExpressionThatMustMatchPartOfTheAnalyzedO']}"/>
                                </ui:define>
                            </ui:decorate>
                        </ui:define>
                        <h:inputText id="stringPatternInputId" value="#{configBeanGui.selectedContentAnalysisConfig.stringPattern}"
                                     styleClass="form-control">
                            <a4j:ajax  event="blur" render="configStringPattern" execute="@this"/>
                        </h:inputText>
                    </s:decorate>

                </s:div>

                <s:div rendered="#{configBeanGui.getSelectedConfig() != null and configBeanGui.getSelectedMimeTypeConfig() != null}">
                    <s:decorate id="configMimeType" template="/layout/form/_form_field_horizontal_3-9.xhtml">
                        <ui:param name="id" value="mimeTypeInputId"/>
                        <ui:param name="styleClass" value=""/>
                        <ui:define name="label">
                            <h:outputText value="#{messages['net.ihe.gazelle.mca.MimeType']}"/>
                            <ui:decorate template="/config/descriptionPopover/_description_popover.xhtml">
                                <ui:param name="id" value="mimeTypeEditId"/>
                                <ui:define name="content">
                                    <h:outputText value="#{messages['net.ihe.gazelle.mca.MimeTypeToBeDetectedForTheAnalyzedObjectToMatchT']}"/>
                                </ui:define>
                            </ui:decorate>
                        </ui:define>
                        <h:inputText id="mimeTypeInputId" value="#{configBeanGui.selectedMimeTypeConfig.mimeType}" required="true"
                                     styleClass="form-control">
                            <a4j:ajax  event="blur" render="configMimeType" execute="@this"/>
                        </h:inputText>
                    </s:decorate>

                </s:div>

                <s:div rendered="#{configBeanGui.getSelectedConfig() != null and configBeanGui.getSelectedTagConfig() != null}">

                    <s:decorate id="configTag" template="/layout/form/_form_field_horizontal_3-9.xhtml">
                        <ui:param name="id" value="tagInputId"/>
                        <ui:param name="styleClass" value=""/>
                        <ui:define name="label">
                            <h:outputText value="#{messages['net.ihe.gazelle.mca.Tag']}"/>
                            <ui:decorate template="/config/descriptionPopover/_description_popover.xhtml">
                                <ui:param name="id" value="tagEditId"/>
                                <ui:define name="content">
                                    <h:outputText value="#{messages['net.ihe.gazelle.mca.XMLTagNameToBeFoundInTheAnalyzedObjectContentItI']}"/>
                                </ui:define>
                            </ui:decorate>
                        </ui:define>
                        <h:inputText id="tagInputId" value="#{configBeanGui.selectedTagConfig.tag}" required="true"
                                     styleClass="form-control">
                            <a4j:ajax  event="blur" render="configTag" execute="@this"/>
                        </h:inputText>
                    </s:decorate>

                    <s:decorate id="configNamespace" template="/layout/form/_form_field_horizontal_3-9.xhtml">
                        <ui:param name="id" value="sampleInputId"/>
                        <ui:param name="styleClass" value=""/>
                        <ui:define name="label">
                            <h:outputText value="#{messages['net.ihe.gazelle.mca.Namespace']}"/>
                            <ui:decorate template="/config/descriptionPopover/_description_popover.xhtml">
                                <ui:param name="id" value="namespaceEditId"/>
                                <ui:define name="content">
                                    <h:outputText value="#{messages['net.ihe.gazelle.mca.NamespaceDefinedForTheTagIfNullThisConfiguration']}"/>
                                </ui:define>
                            </ui:decorate>
                        </ui:define>
                        <h:inputText id="namespaceInputId" value="#{configBeanGui.selectedTagConfig.namespace}"
                                     styleClass="form-control">
                            <a4j:ajax  event="blur" render="configNamespace" execute="@this"/>
                        </h:inputText>
                    </s:decorate>

                </s:div>

                <s:decorate id="configSample" template="/layout/form/_form_field_horizontal_3-9.xhtml">
                    <ui:param name="id" value="sampleInputId"/>
                    <ui:param name="styleClass" value=""/>
                    <ui:define name="label">
                        <h:outputText value="#{messages['net.ihe.gazelle.mca.Sample']}"/>
                        <ui:decorate template="/config/descriptionPopover/_description_popover.xhtml">
                            <ui:param name="id" value="sampleEditId"/>
                            <ui:define name="content">
                                <h:outputText value="#{messages['net.ihe.gazelle.mca.ExampleOfAnalyzedObjectContentThatWouldMatchThis']}"/>
                            </ui:define>
                        </ui:decorate>
                    </ui:define>

                    <h:inputTextarea id="sampleInputId" readonly="false" style="width: 100%"
                                     value="#{configBeanGui.getSelectedConfig().sample}"
                                     rows="8" maxlength="2048"/>
                </s:decorate>

            </s:div>

            <ui:define name="popup_footer">

                <em class="pull-right"><h:outputText value="* #{messages['net.ihe.gazelle.evsclient.Required']}"/></em>

                <a4j:commandButton value="#{messages['gazelle.evs.Save']}"
                                 action="#{configBeanGui.saveSelectedConfig()}"
                                 styleClass="gzl-btn-blue pull-left"
                                 render="configDocType, configMimeType, configTag, configTable"
                                 oncomplete="if(#{configBeanGui.checkRequiredFields()}) {jq162('#modif_config').modal('hide');}"/>

                <a4j:commandButton styleClass="gzl-btn pull-left"
                                   value="#{messages['net.ihe.gazelle.mca.Return']}"
                                   onclick="jq162('#modif_config').modal('hide');"
                                   execute="@this"/>

            </ui:define>
        </ui:decorate>
    </h:form>

</ui:composition>
